/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"time"
)

// checks if the CxTemplateInstallation type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CxTemplateInstallation{}

// CxTemplateInstallation struct for CxTemplateInstallation
type CxTemplateInstallation struct {
	Id *string `json:"id,omitempty"`
	TemplateId *string `json:"template_id,omitempty"`
	Template *CxTemplate `json:"template,omitempty"`
	OrganizationId *string `json:"organization_id,omitempty"`
	ChannelId *string `json:"channel_id,omitempty"`
	Status *string `json:"status,omitempty"`
	PrepareDate *CxTemplateInstallationPrepareDate `json:"prepare_date,omitempty"`
	CustomizationsData []CxTemplateInstallationCustomizationsDataInner `json:"customizations_data,omitempty"`
	WizardData map[string]interface{} `json:"wizard_data,omitempty"`
	Errors []string `json:"errors,omitempty"`
	CreatedAt *time.Time `json:"created_at,omitempty"`
	UpdatedAt *time.Time `json:"updated_at,omitempty"`
	TriggersCustomData []CxTemplateInstallationTriggersCustomDataInner `json:"triggers_custom_data,omitempty"`
	InteractionsCustomData []CxTemplateInstallationInteractionsCustomDataInner `json:"interactions_custom_data,omitempty"`
}

// NewCxTemplateInstallation instantiates a new CxTemplateInstallation object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCxTemplateInstallation() *CxTemplateInstallation {
	this := CxTemplateInstallation{}
	return &this
}

// NewCxTemplateInstallationWithDefaults instantiates a new CxTemplateInstallation object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCxTemplateInstallationWithDefaults() *CxTemplateInstallation {
	this := CxTemplateInstallation{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *CxTemplateInstallation) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallation) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *CxTemplateInstallation) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *CxTemplateInstallation) SetId(v string) {
	o.Id = &v
}

// GetTemplateId returns the TemplateId field value if set, zero value otherwise.
func (o *CxTemplateInstallation) GetTemplateId() string {
	if o == nil || IsNil(o.TemplateId) {
		var ret string
		return ret
	}
	return *o.TemplateId
}

// GetTemplateIdOk returns a tuple with the TemplateId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallation) GetTemplateIdOk() (*string, bool) {
	if o == nil || IsNil(o.TemplateId) {
		return nil, false
	}
	return o.TemplateId, true
}

// HasTemplateId returns a boolean if a field has been set.
func (o *CxTemplateInstallation) HasTemplateId() bool {
	if o != nil && !IsNil(o.TemplateId) {
		return true
	}

	return false
}

// SetTemplateId gets a reference to the given string and assigns it to the TemplateId field.
func (o *CxTemplateInstallation) SetTemplateId(v string) {
	o.TemplateId = &v
}

// GetTemplate returns the Template field value if set, zero value otherwise.
func (o *CxTemplateInstallation) GetTemplate() CxTemplate {
	if o == nil || IsNil(o.Template) {
		var ret CxTemplate
		return ret
	}
	return *o.Template
}

// GetTemplateOk returns a tuple with the Template field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallation) GetTemplateOk() (*CxTemplate, bool) {
	if o == nil || IsNil(o.Template) {
		return nil, false
	}
	return o.Template, true
}

// HasTemplate returns a boolean if a field has been set.
func (o *CxTemplateInstallation) HasTemplate() bool {
	if o != nil && !IsNil(o.Template) {
		return true
	}

	return false
}

// SetTemplate gets a reference to the given CxTemplate and assigns it to the Template field.
func (o *CxTemplateInstallation) SetTemplate(v CxTemplate) {
	o.Template = &v
}

// GetOrganizationId returns the OrganizationId field value if set, zero value otherwise.
func (o *CxTemplateInstallation) GetOrganizationId() string {
	if o == nil || IsNil(o.OrganizationId) {
		var ret string
		return ret
	}
	return *o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallation) GetOrganizationIdOk() (*string, bool) {
	if o == nil || IsNil(o.OrganizationId) {
		return nil, false
	}
	return o.OrganizationId, true
}

// HasOrganizationId returns a boolean if a field has been set.
func (o *CxTemplateInstallation) HasOrganizationId() bool {
	if o != nil && !IsNil(o.OrganizationId) {
		return true
	}

	return false
}

// SetOrganizationId gets a reference to the given string and assigns it to the OrganizationId field.
func (o *CxTemplateInstallation) SetOrganizationId(v string) {
	o.OrganizationId = &v
}

// GetChannelId returns the ChannelId field value if set, zero value otherwise.
func (o *CxTemplateInstallation) GetChannelId() string {
	if o == nil || IsNil(o.ChannelId) {
		var ret string
		return ret
	}
	return *o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallation) GetChannelIdOk() (*string, bool) {
	if o == nil || IsNil(o.ChannelId) {
		return nil, false
	}
	return o.ChannelId, true
}

// HasChannelId returns a boolean if a field has been set.
func (o *CxTemplateInstallation) HasChannelId() bool {
	if o != nil && !IsNil(o.ChannelId) {
		return true
	}

	return false
}

// SetChannelId gets a reference to the given string and assigns it to the ChannelId field.
func (o *CxTemplateInstallation) SetChannelId(v string) {
	o.ChannelId = &v
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *CxTemplateInstallation) GetStatus() string {
	if o == nil || IsNil(o.Status) {
		var ret string
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallation) GetStatusOk() (*string, bool) {
	if o == nil || IsNil(o.Status) {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *CxTemplateInstallation) HasStatus() bool {
	if o != nil && !IsNil(o.Status) {
		return true
	}

	return false
}

// SetStatus gets a reference to the given string and assigns it to the Status field.
func (o *CxTemplateInstallation) SetStatus(v string) {
	o.Status = &v
}

// GetPrepareDate returns the PrepareDate field value if set, zero value otherwise.
func (o *CxTemplateInstallation) GetPrepareDate() CxTemplateInstallationPrepareDate {
	if o == nil || IsNil(o.PrepareDate) {
		var ret CxTemplateInstallationPrepareDate
		return ret
	}
	return *o.PrepareDate
}

// GetPrepareDateOk returns a tuple with the PrepareDate field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallation) GetPrepareDateOk() (*CxTemplateInstallationPrepareDate, bool) {
	if o == nil || IsNil(o.PrepareDate) {
		return nil, false
	}
	return o.PrepareDate, true
}

// HasPrepareDate returns a boolean if a field has been set.
func (o *CxTemplateInstallation) HasPrepareDate() bool {
	if o != nil && !IsNil(o.PrepareDate) {
		return true
	}

	return false
}

// SetPrepareDate gets a reference to the given CxTemplateInstallationPrepareDate and assigns it to the PrepareDate field.
func (o *CxTemplateInstallation) SetPrepareDate(v CxTemplateInstallationPrepareDate) {
	o.PrepareDate = &v
}

// GetCustomizationsData returns the CustomizationsData field value if set, zero value otherwise.
func (o *CxTemplateInstallation) GetCustomizationsData() []CxTemplateInstallationCustomizationsDataInner {
	if o == nil || IsNil(o.CustomizationsData) {
		var ret []CxTemplateInstallationCustomizationsDataInner
		return ret
	}
	return o.CustomizationsData
}

// GetCustomizationsDataOk returns a tuple with the CustomizationsData field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallation) GetCustomizationsDataOk() ([]CxTemplateInstallationCustomizationsDataInner, bool) {
	if o == nil || IsNil(o.CustomizationsData) {
		return nil, false
	}
	return o.CustomizationsData, true
}

// HasCustomizationsData returns a boolean if a field has been set.
func (o *CxTemplateInstallation) HasCustomizationsData() bool {
	if o != nil && !IsNil(o.CustomizationsData) {
		return true
	}

	return false
}

// SetCustomizationsData gets a reference to the given []CxTemplateInstallationCustomizationsDataInner and assigns it to the CustomizationsData field.
func (o *CxTemplateInstallation) SetCustomizationsData(v []CxTemplateInstallationCustomizationsDataInner) {
	o.CustomizationsData = v
}

// GetWizardData returns the WizardData field value if set, zero value otherwise.
func (o *CxTemplateInstallation) GetWizardData() map[string]interface{} {
	if o == nil || IsNil(o.WizardData) {
		var ret map[string]interface{}
		return ret
	}
	return o.WizardData
}

// GetWizardDataOk returns a tuple with the WizardData field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallation) GetWizardDataOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.WizardData) {
		return map[string]interface{}{}, false
	}
	return o.WizardData, true
}

// HasWizardData returns a boolean if a field has been set.
func (o *CxTemplateInstallation) HasWizardData() bool {
	if o != nil && !IsNil(o.WizardData) {
		return true
	}

	return false
}

// SetWizardData gets a reference to the given map[string]interface{} and assigns it to the WizardData field.
func (o *CxTemplateInstallation) SetWizardData(v map[string]interface{}) {
	o.WizardData = v
}

// GetErrors returns the Errors field value if set, zero value otherwise.
func (o *CxTemplateInstallation) GetErrors() []string {
	if o == nil || IsNil(o.Errors) {
		var ret []string
		return ret
	}
	return o.Errors
}

// GetErrorsOk returns a tuple with the Errors field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallation) GetErrorsOk() ([]string, bool) {
	if o == nil || IsNil(o.Errors) {
		return nil, false
	}
	return o.Errors, true
}

// HasErrors returns a boolean if a field has been set.
func (o *CxTemplateInstallation) HasErrors() bool {
	if o != nil && !IsNil(o.Errors) {
		return true
	}

	return false
}

// SetErrors gets a reference to the given []string and assigns it to the Errors field.
func (o *CxTemplateInstallation) SetErrors(v []string) {
	o.Errors = v
}

// GetCreatedAt returns the CreatedAt field value if set, zero value otherwise.
func (o *CxTemplateInstallation) GetCreatedAt() time.Time {
	if o == nil || IsNil(o.CreatedAt) {
		var ret time.Time
		return ret
	}
	return *o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallation) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.CreatedAt) {
		return nil, false
	}
	return o.CreatedAt, true
}

// HasCreatedAt returns a boolean if a field has been set.
func (o *CxTemplateInstallation) HasCreatedAt() bool {
	if o != nil && !IsNil(o.CreatedAt) {
		return true
	}

	return false
}

// SetCreatedAt gets a reference to the given time.Time and assigns it to the CreatedAt field.
func (o *CxTemplateInstallation) SetCreatedAt(v time.Time) {
	o.CreatedAt = &v
}

// GetUpdatedAt returns the UpdatedAt field value if set, zero value otherwise.
func (o *CxTemplateInstallation) GetUpdatedAt() time.Time {
	if o == nil || IsNil(o.UpdatedAt) {
		var ret time.Time
		return ret
	}
	return *o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallation) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.UpdatedAt) {
		return nil, false
	}
	return o.UpdatedAt, true
}

// HasUpdatedAt returns a boolean if a field has been set.
func (o *CxTemplateInstallation) HasUpdatedAt() bool {
	if o != nil && !IsNil(o.UpdatedAt) {
		return true
	}

	return false
}

// SetUpdatedAt gets a reference to the given time.Time and assigns it to the UpdatedAt field.
func (o *CxTemplateInstallation) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = &v
}

// GetTriggersCustomData returns the TriggersCustomData field value if set, zero value otherwise.
func (o *CxTemplateInstallation) GetTriggersCustomData() []CxTemplateInstallationTriggersCustomDataInner {
	if o == nil || IsNil(o.TriggersCustomData) {
		var ret []CxTemplateInstallationTriggersCustomDataInner
		return ret
	}
	return o.TriggersCustomData
}

// GetTriggersCustomDataOk returns a tuple with the TriggersCustomData field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallation) GetTriggersCustomDataOk() ([]CxTemplateInstallationTriggersCustomDataInner, bool) {
	if o == nil || IsNil(o.TriggersCustomData) {
		return nil, false
	}
	return o.TriggersCustomData, true
}

// HasTriggersCustomData returns a boolean if a field has been set.
func (o *CxTemplateInstallation) HasTriggersCustomData() bool {
	if o != nil && !IsNil(o.TriggersCustomData) {
		return true
	}

	return false
}

// SetTriggersCustomData gets a reference to the given []CxTemplateInstallationTriggersCustomDataInner and assigns it to the TriggersCustomData field.
func (o *CxTemplateInstallation) SetTriggersCustomData(v []CxTemplateInstallationTriggersCustomDataInner) {
	o.TriggersCustomData = v
}

// GetInteractionsCustomData returns the InteractionsCustomData field value if set, zero value otherwise.
func (o *CxTemplateInstallation) GetInteractionsCustomData() []CxTemplateInstallationInteractionsCustomDataInner {
	if o == nil || IsNil(o.InteractionsCustomData) {
		var ret []CxTemplateInstallationInteractionsCustomDataInner
		return ret
	}
	return o.InteractionsCustomData
}

// GetInteractionsCustomDataOk returns a tuple with the InteractionsCustomData field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallation) GetInteractionsCustomDataOk() ([]CxTemplateInstallationInteractionsCustomDataInner, bool) {
	if o == nil || IsNil(o.InteractionsCustomData) {
		return nil, false
	}
	return o.InteractionsCustomData, true
}

// HasInteractionsCustomData returns a boolean if a field has been set.
func (o *CxTemplateInstallation) HasInteractionsCustomData() bool {
	if o != nil && !IsNil(o.InteractionsCustomData) {
		return true
	}

	return false
}

// SetInteractionsCustomData gets a reference to the given []CxTemplateInstallationInteractionsCustomDataInner and assigns it to the InteractionsCustomData field.
func (o *CxTemplateInstallation) SetInteractionsCustomData(v []CxTemplateInstallationInteractionsCustomDataInner) {
	o.InteractionsCustomData = v
}

func (o CxTemplateInstallation) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CxTemplateInstallation) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if !IsNil(o.TemplateId) {
		toSerialize["template_id"] = o.TemplateId
	}
	if !IsNil(o.Template) {
		toSerialize["template"] = o.Template
	}
	if !IsNil(o.OrganizationId) {
		toSerialize["organization_id"] = o.OrganizationId
	}
	if !IsNil(o.ChannelId) {
		toSerialize["channel_id"] = o.ChannelId
	}
	if !IsNil(o.Status) {
		toSerialize["status"] = o.Status
	}
	if !IsNil(o.PrepareDate) {
		toSerialize["prepare_date"] = o.PrepareDate
	}
	if !IsNil(o.CustomizationsData) {
		toSerialize["customizations_data"] = o.CustomizationsData
	}
	if !IsNil(o.WizardData) {
		toSerialize["wizard_data"] = o.WizardData
	}
	if !IsNil(o.Errors) {
		toSerialize["errors"] = o.Errors
	}
	if !IsNil(o.CreatedAt) {
		toSerialize["created_at"] = o.CreatedAt
	}
	if !IsNil(o.UpdatedAt) {
		toSerialize["updated_at"] = o.UpdatedAt
	}
	if !IsNil(o.TriggersCustomData) {
		toSerialize["triggers_custom_data"] = o.TriggersCustomData
	}
	if !IsNil(o.InteractionsCustomData) {
		toSerialize["interactions_custom_data"] = o.InteractionsCustomData
	}
	return toSerialize, nil
}

type NullableCxTemplateInstallation struct {
	value *CxTemplateInstallation
	isSet bool
}

func (v NullableCxTemplateInstallation) Get() *CxTemplateInstallation {
	return v.value
}

func (v *NullableCxTemplateInstallation) Set(val *CxTemplateInstallation) {
	v.value = val
	v.isSet = true
}

func (v NullableCxTemplateInstallation) IsSet() bool {
	return v.isSet
}

func (v *NullableCxTemplateInstallation) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCxTemplateInstallation(val *CxTemplateInstallation) *NullableCxTemplateInstallation {
	return &NullableCxTemplateInstallation{value: val, isSet: true}
}

func (v NullableCxTemplateInstallation) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCxTemplateInstallation) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


